/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 * 
 *  DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 *
 *  This code is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License version 3, 
 *  or (at your option) any later version, as published by the Free Software Foundation.  
 *  The authors designate this particular file as subject to the "Classpath" exception 
 *  as provided in the LICENSE file that accompanied this code.
 *
 *  This code is distributed in the hope that it will be useful, but WITHOUT
 *  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 *  version 3 for more details (a copy is included in the LICENSE file that
 *  accompanied this code).
 *
 *  You should have received a copy of the GNU General Public License version 3
 *  along with this work; if not, see http://www.gnu.org/licenses/gpl-3.0.txt 
 *
 *  Please contact visnow.org or visit www.visnow.org if you need additional information or
 *  have any questions.
 *
 */

package org.visnow.vn.geometries.gui;

import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import javax.swing.BorderFactory;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JComboBox;
import javax.swing.JPanel;
import javax.swing.JSlider;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import org.visnow.jscic.DataContainerSchema;
import org.visnow.vn.geometries.parameters.VolumeShadingParams;
import org.visnow.vn.geometries.parameters.VolumeShadingParams.ShadingType;
import static org.visnow.vn.geometries.parameters.VolumeShadingParams.ShadingType.*;
import org.visnow.vn.gui.widgets.FloatSubRangeSlider.FloatSubRangeSlider;
import org.visnow.vn.lib.gui.DataComponentSelector;

/**
 *
 * @author know
 */


public class VolumeShadingGUI extends javax.swing.JPanel
{
    protected ShadingType[] types = {NO_SHADING, TRANSPARENCY_GRADIENT, COMPONENT_GRADIENT};

    protected VolumeShadingParams params;
    /**
     * Creates new form VolumeShadingPanel
     */
    public VolumeShadingGUI()
    {
        initComponents();
        shadingComponentSelector.setEnabled(false);
        shadingIntensitySlider.setEnabled(false);
        gradientRangeSlider.setEnabled(false);
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        GridBagConstraints gridBagConstraints;

        shadingIntensitySlider = new JSlider();
        jPanel3 = new JPanel();
        gradientRangeSlider = new FloatSubRangeSlider();
        shadingComponentSelector = new DataComponentSelector();
        shadingTypeBox = new JComboBox();

        setBorder(BorderFactory.createTitledBorder("Volume shading controls"));
        setLayout(new GridBagLayout());

        shadingIntensitySlider.setMajorTickSpacing(20);
        shadingIntensitySlider.setMinorTickSpacing(5);
        shadingIntensitySlider.setPaintTicks(true);
        shadingIntensitySlider.setValue(30);
        shadingIntensitySlider.setBorder(BorderFactory.createTitledBorder("intensity"));
        shadingIntensitySlider.setOpaque(false);
        shadingIntensitySlider.setPreferredSize(new Dimension(80, 48));
        shadingIntensitySlider.addChangeListener(new ChangeListener() {
            public void stateChanged(ChangeEvent evt) {
                shadingIntensitySliderStateChanged(evt);
            }
        });
        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 0.5;
        add(shadingIntensitySlider, gridBagConstraints);
        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = GridBagConstraints.BOTH;
        gridBagConstraints.weighty = 1.0;
        add(jPanel3, gridBagConstraints);

        gradientRangeSlider.setBorder(BorderFactory.createTitledBorder("gradient range"));
        gradientRangeSlider.setToolTipText("<html>determines transformation of component or transparency gradient \nto shading intensity:<p>\nmove range to the right to highlight only prominent contours, <p>\nmove range to the left to highlight subtle value changes</html>");
        gradientRangeSlider.setBottomValue(-1.0F);
        gradientRangeSlider.setMaximum(3.0F);
        gradientRangeSlider.setMinimum(-3.0F);
        gradientRangeSlider.setPreferredSize(new Dimension(120, 55));
        gradientRangeSlider.setTopValue(1.0F);
        gradientRangeSlider.addChangeListener(new ChangeListener() {
            public void stateChanged(ChangeEvent evt) {
                gradientRangeSliderStateChanged(evt);
            }
        });
        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        add(gradientRangeSlider, gridBagConstraints);

        shadingComponentSelector.setPreferredSize(new Dimension(120, 25));
        shadingComponentSelector.setTitle("");
        shadingComponentSelector.addChangeListener(new ChangeListener() {
            public void stateChanged(ChangeEvent evt) {
                shadingComponentSelectorStateChanged(evt);
            }
        });
        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = GridBagConstraints.HORIZONTAL;
        add(shadingComponentSelector, gridBagConstraints);

        shadingTypeBox.setModel(new DefaultComboBoxModel(new String[] { "no shading", "transparency", "component", "" }));
        shadingTypeBox.setToolTipText("");
        shadingTypeBox.setMinimumSize(new Dimension(60, 23));
        shadingTypeBox.setOpaque(false);
        shadingTypeBox.setPreferredSize(new Dimension(80, 23));
        shadingTypeBox.addItemListener(new ItemListener() {
            public void itemStateChanged(ItemEvent evt) {
                shadingTypeBoxItemStateChanged(evt);
            }
        });
        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new Insets(0, 3, 0, 3);
        add(shadingTypeBox, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents

    private void shadingIntensitySliderStateChanged(ChangeEvent evt)//GEN-FIRST:event_shadingIntensitySliderStateChanged
    {//GEN-HEADEREND:event_shadingIntensitySliderStateChanged
        if (!shadingIntensitySlider.getValueIsAdjusting())
            params.setShadingIntensity(shadingIntensitySlider.getValue() / 100.f);
    }//GEN-LAST:event_shadingIntensitySliderStateChanged

    private void gradientRangeSliderStateChanged(ChangeEvent evt)//GEN-FIRST:event_gradientRangeSliderStateChanged
    {//GEN-HEADEREND:event_gradientRangeSliderStateChanged
        if (!gradientRangeSlider.isAdjusting()) {
           float l = gradientRangeSlider.getBottomValue();
           float u = gradientRangeSlider.getTopValue();
           params.setShadingRange(new float[]{(float)Math.pow(10, l),(float)Math.pow(10, u)});
        }
    }//GEN-LAST:event_gradientRangeSliderStateChanged

    private void shadingComponentSelectorStateChanged(ChangeEvent evt) {//GEN-FIRST:event_shadingComponentSelectorStateChanged
        params.setShadingComponent(shadingComponentSelector.getComponentName());
    }//GEN-LAST:event_shadingComponentSelectorStateChanged

    private void shadingTypeBoxItemStateChanged(ItemEvent evt)//GEN-FIRST:event_shadingTypeBoxItemStateChanged
    {//GEN-HEADEREND:event_shadingTypeBoxItemStateChanged
        params.setShadingType(types[shadingTypeBox.getSelectedIndex()]);
        shadingIntensitySlider.setEnabled(shadingTypeBox.getSelectedIndex() > 0);
        gradientRangeSlider.setEnabled(shadingTypeBox.getSelectedIndex() > 0);
        shadingComponentSelector.setEnabled(shadingTypeBox.getSelectedIndex() > 1);
    }//GEN-LAST:event_shadingTypeBoxItemStateChanged


    public void setParams(VolumeShadingParams params) {
        this.params = params;
        shadingComponentSelector.setDataSchema(params.getComponent().getContainerSchema());
        params.setGui(this);
    }
    
    public void setDataContainer(DataContainerSchema containerSchema)
    {
        shadingComponentSelector.setDataSchema(containerSchema);
    }
    
    public void updateDataValuesFromParams()
    {
        
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    protected FloatSubRangeSlider gradientRangeSlider;
    protected JPanel jPanel3;
    protected DataComponentSelector shadingComponentSelector;
    protected JSlider shadingIntensitySlider;
    protected JComboBox shadingTypeBox;
    // End of variables declaration//GEN-END:variables
}
